/**
 * Hashing
 * 
 * Namen der Mitglieder und Matrikelnummern hier.
 */
public class Hashing {

    /**
     * Status fr Hash-Eintrge.
     * Bitte nicht ndern!
     */
    public static final int free = 0, used = 1, deleted = -1;

    /**
     * Einfgen mit doppeltem Hashing.
     * Bitte nicht ndern!
     */
    public static int insert1(Hash table[], int k) {
        int numOfCollisions = 0;
        int m = table.length;
        int insertPos = mod(h1(k), m);
        int nextPos = insertPos;
        while (table[nextPos].state == used) {
            int nextKey = insertPos + h2(k) + numOfCollisions;
            nextPos = mod(nextKey, m);
            numOfCollisions++;
        }
        table[nextPos].key = k;
        table[nextPos].state = used;
        return numOfCollisions;
    }

    /**
     * Einfgen mit Variante von doppeltem Hashing.
     * Hier sind die mit Kommentaren markierten Zeilen zu vervollstndigen!
     */
    public static int insert2(Hash table[], int k) {
        int numOfCollisions = 0;
        int m = table.length;
        int insertPos = mod(h1(k), m);
        while (table[insertPos].state == used) {
            int nextNewKey = // IMPLEMENT ME
            int nextOldKey = // IMPLEMENT ME
            int newNext = mod(nextNewKey, m);
            int oldNext = mod(nextOldKey, m);
            if (table[newNext].state == free || table[oldNext].state == used) {
                insertPos = newNext;
            } else {
                table[oldNext].key = // IMPLEMENT ME
                table[oldNext].state = used;
                table[insertPos].state = deleted;
            }
            numOfCollisions++;
        }
        table[insertPos].key = k;
        table[insertPos].state = used;
        return numOfCollisions;
    }

    /**
     * Eine Hash-Funktion.
     * Bitte nicht ndern!
     */
    private static int h1(int key) {
        return Math.abs(3 * key * key);
    }

    /**
     * Eine Hash-Funktion.
     * Bitte nicht ndern!
     */
    private static int h2(int key) {
        return Math.abs(7 * key * key * key);
    }

    /**
     * Die modulo Operation - modifiziert gegenber der Standard 
     * Java-Implementierung, sodass das Ergebnis nicht negativ sein kann.
     * Bitte nicht ndern!
     */
    private static int mod(int value, int limit) {
        if (value < 0) {
            value = -value;
            while (value > limit) {
                value -= limit;
            }
            return limit - value;
        } else {
            return value % limit;
        }
    }

}
